//************************************************************************************
//**  
//**  File name:     C:\APPLI\CIRCUIT\scannerXY_usb\prog_flowcode\version_multiboard\test.c
//**  Generated by:  Flowcode v4.4.13.69
//**  Date:          Thursday, June 23, 2016 15:55:04
//**  Licence:       Professional
//**  Registered to: UNIVERSITE-TROYES
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC_16BIT

//Dfinir pour microcontrleur
#define PIC24
#define P24FJ64GB004
#define MX_CLKS_PER_INST 2
#define MX_SPI1
#define MX_SPI1_PORT_FREEALLOC
#define MX_SPI2
#define MX_SPI2_PORT_FREEALLOC
#define MX_UART1
#define MX_UART1_PORT_FREEALLOC
#define MX_UART1_ALT
#define MX_UART2
#define MX_UART2_PORT_FREEALLOC
#define MX_MI2C1
#define MX_I2C1_PORT_B
#define MX_I2C1_SDA 9
#define MX_I2C1_SCL 8
#define MX_MI2C2
#define MX_I2C2_PORT_B
#define MX_I2C2_SDA 2
#define MX_I2C2_SCL 3
#define MX_PWM
#define MX_PWM_PORT_FREEALLOC
#define MX_PWM_CNT 5
#define MX_PWM_1 0
#define MX_PWM_2 1
#define MX_USB

//Fonctions
#define MX_Fosc 32000000

#include "../support/PIC24F/h/p24Fxxxx.h"
#include <stdlib.h>
#include <math.h>

//Donnes de Configuration
_CONFIG1(0x3f7f)  //addr = 0xabfe
_CONFIG2(0x1bad)  //addr = 0xac00
_CONFIG3(0xfcff)  //addr = 0xac02
_CONFIG4(0xff3f)  //addr = 0xac04

//Fonctions internes
#include "C:\Program Files\Flowcode_PIC24_dsPIC_V4\FCD\internals.h"

//Dclarations de fonction Macro
void FCM_service_macro();


//Dclarations de Variable
#define FCSZ_STR 20
volatile char FCV_RETVAL;
volatile short FCV_WR_DDS;
volatile short FCV_WR_MEM;
volatile short FCV_INCR;
volatile short FCV_WR_DAC;
volatile char FCV_COMMAND;
volatile char FCV_SEL_DAC;
volatile char FCV_BYTE1;
volatile char FCV_CHAR_TMP;
volatile char FCV_BYTE2;
volatile char FCV_ADD_EEPROM;
volatile short FCV_WR_CPLD;
volatile char FCV_SEL_CANAL;
volatile short FCV_VAL_DAC;
volatile short FCV_ENTIER_TMP;
volatile char FCV_STR[FCSZ_STR];
volatile short FCV_FREQ0_LSB;
volatile char FCV_INDEX_C;
volatile short FCV_FREQ0_MSB;
volatile char FCV_MODE_EEPROM;


//Defines:

/**** Macro Substitutions ****
0x12BF = Vendor ID
0xF030 = Product ID
'F','l','o','w','c','o','d','e',' ','U','S','B',' ','S','l','a','v','e' = Device Name
'M','a','t','r','i','x',' ','M','u','l','t','i','m','e','d','i','a',' ','L','t','d','.' = Device manufacturer
0 = Version Number A
1 = Version Number B
10 = Enumeration Wait Enable
0 = Enumeration Wait Time
25 = Maximum Usage Current
0 = Country Code
service_macro = Macro Name
0 = Macro Parameter Set
18 = Length of Device Name String
22 = Length of Device Manufacturer String
******************************/

	// Component Defines
	#define MX_VID 			0x12BF					//Eg 0x12bf
	#define MX_PID 			0xF030					//Eg 0x0020
	#define MX_VERSION		(1 << 8) + 0		//Eg 0x0200 = 2.0
	#define MX_ENUMTIME		10					//Eg 1 - 255
	#define MX_ENUMWAIT		0					//Eg 1 or 0

	#define MX_MAX_CURRENT	25					//x2 mA so 0x05 = 10mA
	#define MX_COUNTRY		0					//default is 0
	#define MX_MACRO1       service_macro					//USB_Service
	#define PARAM_SET		0					//0=char,char,char / 1=char,string

	// Command Defines
	#define MX_CMD_WR_REG	0
	#define MX_CMD_RE_REG	1
	#define MX_CMD_MACRO1	2
	#define MX_CMD_MACRO2	3

	// Global Defines
	#define USB_BUS_SENSE       1
	#define self_power          1
	#define tris_usb_bus_sense	1
	#define tris_self_power		1

	#define USB_CONFIG	"usb_generic_config.h"
	char transfer = 0;
	char reply = 0;

	// USB library includes
	#include "../../USB/usb_generic_config.h"
	#include "../../USB/usb.h"
	#include "../../USB/usb_function_generic.h"
	#include "../../USB/GenericTypeDefs.h"
	#include "../../USB/Compiler.h"
	#include "../../USB/usb_device.h"
	#include "../../USB/usb_device.c"
	#include "../../USB/usb_ch9.h"
	#include "../../USB/usb_hal_pic24.c"
	#include "../../USB/usb_function_generic.c"
	#include "../../USB/usb_common.h"
	#include "../../USB/usb_hal.h"
	#include "../../USB/usb_hal_pic24.h"

	// Device name and manufacturer
	ROM struct{BYTE bLength;BYTE bDscType;WORD string[18];}sd001={sizeof(sd001),USB_DESCRIPTOR_STRING,{'F','l','o','w','c','o','d','e',' ','U','S','B',' ','S','l','a','v','e'}};
	ROM struct{BYTE bLength;BYTE bDscType;WORD string[22];}sd002={sizeof(sd002),USB_DESCRIPTOR_STRING,{'M','a','t','r','i','x',' ','M','u','l','t','i','m','e','d','i','a',' ','L','t','d','.'}};

	USB_HANDLE USBGenericOutHandle = 0;
	USB_HANDLE USBGenericInHandle = 0;

	DATA_PACKET INPacket;
	DATA_PACKET OUTPacket;

	#include "../../USB/usb_generic_descriptors.c"
	#include "../../USB/usb_generic_handler.c"

	char Slave_Service_Status = 0;




//USBSlave(0): //Dclarations de fonction Macro

static char FCD_USBSlave0_IsTxBusy();
static char FCD_USBSlave0_Initialise_Slave();
static char FCD_USBSlave0_Check_Rx();
static char FCD_USBSlave0_Get_Byte(char Idx);
static void FCD_USBSlave0_Get_String(char* FCR_RETVAL, char FCR_RETVAL_SIZE, char NumBytes);
static char FCD_USBSlave0_Send_Byte(char Byte);
static char FCD_USBSlave0_Send_String(char* String, char MSZ_String, char Length);
static void FCD_USBSlave0_Run_Slave_Service();
static void FCD_USBSlave0_Stop_Slave_Service();



//USBSlave(0): //Implmentations Macro


static char FCD_USBSlave0_IsTxBusy()
{
		return USBHandleBusy(USBGenericInHandle);
}

static char FCD_USBSlave0_Initialise_Slave()
{
	
		USBDeviceInit();

		if(USB_BUS_SENSE && (USBGetDeviceState() == DETACHED_STATE))
		{
			USBDeviceAttach();
		}

		#if MX_ENUMWAIT == 1

			unsigned int delay_counter = 0;

			while(USBDeviceState != CONFIGURED_STATE && delay_counter < 10000)	//Wait for USB to startup and enumerate
			{
				delay_counter = delay_counter + 1;
				delay_10us(MX_ENUMTIME);						//Max wait 10 seconds
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
			}

			if (USBDeviceState == CONFIGURED_STATE)
				return 0;

			return 0xFF;

		#else

			while(USBDeviceState != CONFIGURED_STATE);

		#endif
		return 0;
}

static char FCD_USBSlave0_Check_Rx()
{
	
		char retval = 0;

		if (!USBHandleBusy(USBGenericOutHandle))
		{
			retval = transfer;			//Return length
			transfer = 0;
		}

		return retval;

}

static char FCD_USBSlave0_Get_Byte(char Idx)
{
	
		if(Idx >= USBGEN_EP_SIZE)		//If index greater then length of string
			return 0;							//return 0

		return OUTPacket._byte[Idx];			//Otherwise return byte from string

}

static void FCD_USBSlave0_Get_String(char* FCR_RETVAL, char FCR_RETVAL_SIZE, char NumBytes)
{
	
		unsigned int i;

		if(NumBytes > FCR_RETVAL_SIZE)
			NumBytes = FCR_RETVAL_SIZE;

		if (NumBytes > USBGEN_EP_SIZE)		//If length greater then length of string
			NumBytes = USBGEN_EP_SIZE;		//Make length equal to length of string

		for (i=0; i<NumBytes; i++)					//Step through each byte of the string
		{
			FCR_RETVAL[i] = OUTPacket._byte[i];		//Store the incoming value into the string
		}

		FCR_RETVAL[i] = 0;							//Terminate the string with null character

}

static char FCD_USBSlave0_Send_Byte(char Byte)
{
	
		unsigned int timeout = 0;

		INPacket._byte[0] = Byte;					//Place data into the string to be sent
		while( FCD_USBSlave0_IsTxBusy() && timeout < 32000)		//Wait for any previous transmissions to finish
			timeout = timeout + 1;

		if (timeout == 32000)
			return 1;

		USBGenericInHandle = USBGenWrite(USBGEN_EP_NUM,(BYTE*)&INPacket,1);

		reply = 1;

		USBGenericOutHandle = USBGenRead(USBGEN_EP_NUM,(BYTE*)&OUTPacket,USBGEN_EP_SIZE);

		return 0;

}

static char FCD_USBSlave0_Send_String(char* String, char MSZ_String, char Length)
{
	
		unsigned int timeout = 0;
		unsigned int i;

		if (Length >= USBGEN_EP_SIZE)				//If send string is larger then send buffer
			Length = USBGEN_EP_SIZE;

		for (i=0; i<Length; i++)
		{
			INPacket._byte[i] = String[i];		//Place data into the string to be sent
		}

		while( FCD_USBSlave0_IsTxBusy() && timeout < 32000)		//Wait for any previous transmissions to finish
			timeout = timeout + 1;

		if (timeout == 32000)
			return 1;

		reply = 1;

		USBGenericInHandle = USBGenWrite(USBGEN_EP_NUM,(BYTE*)&INPacket,Length);
		USBGenericOutHandle = USBGenRead(USBGEN_EP_NUM,(BYTE*)&OUTPacket,USBGEN_EP_SIZE);

		return 0;

}

static void FCD_USBSlave0_Run_Slave_Service()
{
	
			char i, length;
			char temp_str[31] = "";
			short a,b,c;

			Slave_Service_Status = 1;
			while (Slave_Service_Status)
			{
				length = FCD_USBSlave0_Check_Rx();
				if (length)
				{
					reply = 0;

					#if PARAM_SET == 0
						FCM_service_macro();
					#endif

					#if PARAM_SET == 1										//Params char
						FCM_service_macro(OUTPacket._byte[0]);
					#endif

					#if PARAM_SET == 2										//Params char, char
						FCM_service_macro(OUTPacket._byte[0],OUTPacket._byte[1]);
					#endif

					#if PARAM_SET == 3										//Params char, char, char
						FCM_service_macro(OUTPacket._byte[0],OUTPacket._byte[1],OUTPacket._byte[2]);
					#endif

					#if PARAM_SET == 4										//Params char, char, char, char
						FCM_service_macro(OUTPacket._byte[0],OUTPacket._byte[1],OUTPacket._byte[2],OUTPacket._byte[3]);
					#endif

					#if PARAM_SET == 5										//Params char, char, char, char, char
						FCM_service_macro(OUTPacket._byte[0],OUTPacket._byte[1],OUTPacket._byte[2],OUTPacket._byte[3],OUTPacket._byte[4]);
					#endif

					#if PARAM_SET == 6										//Params int
						a = OUTPacket._byte[0] | (OUTPacket._byte[1] << 8);
						FCM_service_macro(a);
					#endif

					#if PARAM_SET == 7										//Params int, char
						a = OUTPacket._byte[0] | (OUTPacket._byte[1] << 8);
						FCM_service_macro(a,OUTPacket._byte[2]);
					#endif

					#if PARAM_SET == 8										//Params int, char, char
						a = OUTPacket._byte[0] | (OUTPacket._byte[1] << 8);
						FCM_service_macro(a,OUTPacket._byte[2],OUTPacket._byte[3]);
					#endif

					#if PARAM_SET == 9										//Params int, int
						a = OUTPacket._byte[0] | (OUTPacket._byte[1] << 8);
						b = OUTPacket._byte[2] | (OUTPacket._byte[3] << 8);
						FCM_service_macro(a, b);
					#endif

					#if PARAM_SET == 10										//Params int, int, int
						a = OUTPacket._byte[0] | (OUTPacket._byte[1] << 8);
						b = OUTPacket._byte[2] | (OUTPacket._byte[3] << 8);
						c = OUTPacket._byte[4] | (OUTPacket._byte[5] << 8);
						FCM_service_macro(a, b, c);
					#endif

					#if PARAM_SET == 11										//Params string
						for (i=0; i<(length); i++)
						{
							temp_str[i] = OUTPacket._byte[i];
						}
						FCM_service_macro(temp_str);
					#endif

					#if PARAM_SET == 12										//Params char, string
						for (i=0; i<(length - 1); i++)
						{
							temp_str[i] = OUTPacket._byte[i+1];
						}
						FCM_service_macro(OUTPacket._byte[0], temp_str);
					#endif

					#if PARAM_SET == 13										//Params int, string
						a = OUTPacket._byte[0] | (OUTPacket._byte[1] << 8);
						for (i=0; i<(length - 2); i++)
						{
							temp_str[i] = OUTPacket._byte[i+2];
						}
						FCM_service_macro(a, temp_str);
					#endif

					if (reply == 0)
					{
						USBGenericInHandle = USBGenWrite(USBGEN_EP_NUM,(BYTE*)&OUTPacket,1);
					}
					USBGenericOutHandle = USBGenRead(USBGEN_EP_NUM,(BYTE*)&OUTPacket,USBGEN_EP_SIZE);
				}
		}

}

static void FCD_USBSlave0_Stop_Slave_Service()
{
	
		Slave_Service_Status = 0;

}

//Implmentations Macro

void FCM_service_macro()
{
	
}

int main()
{
	
	//Initialisation
	AD1PCFG = 0xffff;

	
	   #if defined(P24FJ64GB004) || defined(P24FJ64GB002) || defined(P24FJ32GB004) || defined(P24FJ32GB002)
		//On the PIC24FJ64GB004 Family of USB microcontrollers, the PLL will not power up and be enabled
		//by default, even if a PLL enabled oscillator configuration is selected (such as HS+PLL).
		//This allows the device to power up at a lower initial operating frequency, which can be
		//advantageous when powered from a source which is not gauranteed to be adequate for 32MHz
		//operation.  On these devices, user firmware needs to manually set the CLKDIV<PLLEN> bit to
		//power up the PLL.
	    {
	        unsigned int pll_startup_counter = 600;
	        CLKDIVbits.PLLEN = 1;
	        while(pll_startup_counter--);
	    }
	    #endif

	    #ifndef MX_USB
	    	#error "Your target device does not support USB components"
	    #endif


	//Code d'initialisation d'Interruption
	
	//Point de Jonction
	//Point de Jonction: [A]: A
FCC_Principal_A:
;


	//Appel de la Routine Composant
	//Appel de la Routine Composant: USBSlave(0)::Initialise_Slave
	FCD_USBSlave0_Initialise_Slave();


	//Loop
	//Boucle: Tant que 1
	while (1)
	{
		//Check for Incoming Data
		//Appel de la Routine Composant: RetVal=USBSlave(0)::Check_Rx
		FCV_RETVAL = FCD_USBSlave0_Check_Rx();


		//If data available
		//Dcision: RetVal?
		if (FCV_RETVAL)
		{
			//byte0 is the command
			//Appel de la Routine Composant: command=USBSlave(0)::Get_Byte(0)
			FCV_COMMAND = FCD_USBSlave0_Get_Byte(0);


			//Appel de la Routine Composant
			//Appel de la Routine Composant: byte1=USBSlave(0)::Get_Byte(1)
			FCV_BYTE1 = FCD_USBSlave0_Get_Byte(1);


			//Appel de la Routine Composant
			//Appel de la Routine Composant: byte2=USBSlave(0)::Get_Byte(2)
			FCV_BYTE2 = FCD_USBSlave0_Get_Byte(2);


			//version
			//Dcision: command = 0?
			if (FCV_COMMAND == 0)
			{
				//Aller au Point de Jonction
				//Aller au Point de Jonction: [A]: A
				goto FCC_Principal_A;


			}


			//ecrire memoire
			//Dcision: command = 1?
			if (FCV_COMMAND == 1)
			{
				//Appel de la Routine Composant
				//Appel de la Routine Composant: USBSlave(0)::Send_String("c11", 3)
				FCD_USBSlave0_Send_String("c11",3, 3);


			}


			//selection DAC
			//Dcision: command = 2?
			if (FCV_COMMAND == 2)
			{
				//Appel de la Routine Composant
				//Appel de la Routine Composant: USBSlave(0)::Send_String("c12", 3)
				FCD_USBSlave0_Send_String("c12",3, 3);


			}


			//crire DAC
			//Dcision: command = 3?
			if (FCV_COMMAND == 3)
			{
				//Appel de la Routine Composant
				//Appel de la Routine Composant: USBSlave(0)::Send_String("c13", 3)
				FCD_USBSlave0_Send_String("c13",3, 3);


			}


		}


	}


	mainendloop: goto mainendloop;
	return 0;
}



